#include <sourcemod>
#include <sdktools>
#include <vip>

#define FILE_PATH		"addons/sourcemod/configs/vip/skincolor.cfg" 
#define ITEM_NAME		"skincolor"
#define MAX_COLORS		32

public Plugin:myinfo = 
{
	name	= "[VIP Module] SkinColor",
	author	= "The End Is Near...",
	version	= "1.2",
	url		= "https://world-source.ru/"
};

new g_iItemID = -1;

new Handle:g_hGlobalMenu = INVALID_HANDLE;

new bool:g_bIsClientVip[MAXPLAYERS + 1] = {false, ...};

new g_iClientSelectColor[MAXPLAYERS + 1] = {0, ...},
	g_iColorsOfFile[MAX_COLORS + 1][4];

public OnPluginStart()
{
	if ((g_iItemID = VIP_RegisterItem(ITEM_NAME, false, true)) < 1)
	{
		SetFailState("VIP_RegisterItem error");
	}
}

public OnPluginEnd()
{
	VIP_UnRegisterItem(ITEM_NAME);
}

public VIP_OnClientAuthorized(iClientID, const String:szSteamID[], bool:bVip, const String:szGroup[])
{
	if (bVip == true)
	{
		CheckPlayer(iClientID);
	}
}

public VIP_OnRemoved(iClientID, const String:szSteamID[], const String:szReason[])
{
	if (g_iClientSelectColor[iClientID] != 0)
	{
		ChangeColorSkin(iClientID, 255, 255, 255, 255);
	}
}

public VIP_OnGroupChanged(iClientID, const String:szSteamID[], const String:szOldGroup[], const String:szNewGroup[])
{
	CheckPlayer(iClientID);
}

public VIP_OnAdded(iClientID, const String:szSteamID[], const String:szGroup[], iMin, const String:szAdminSteamID[])
{
	if (iClientID > 0)
	{
		CheckPlayer(iClientID);
	}
}

CheckPlayer(iClientID)
{
	decl String:szItemInfo[MAX_ITEMINFO_LENGTH];
	if (VIP_ItemDisabled(ITEM_NAME) == false && VIP_GetClientItemInfo(iClientID, ITEM_NAME, szItemInfo) == true)
	{
		g_bIsClientVip[iClientID] = true;
	}
	else
	{
		g_bIsClientVip[iClientID] = false;

		ChangeColorSkin(iClientID, 255, 255, 255, 255);
	}
}

public VIP_OnVipItemPressed(iClientID, iItemID, const String:szItemName[], const String:szItemInfo[])
{
	if (g_iItemID == iItemID)
	{
		DisplayMenu(g_hGlobalMenu, iClientID, MENU_TIME_FOREVER);
	}
}

public OnClientConnected(iClientID)
{
	g_bIsClientVip[iClientID] = false;
	g_iClientSelectColor[iClientID] = 0;
}

public OnConfigsExecuted()
{
	new Handle:hKeyValues = CreateKeyValues(ITEM_NAME);
	if (FileToKeyValues(hKeyValues, FILE_PATH) == false) 
	{ 
		SetFailState("Could not open file '%s'", FILE_PATH);
	}

	if (g_hGlobalMenu != INVALID_HANDLE)
	{
		CloseHandle(g_hGlobalMenu);
	}

	g_hGlobalMenu = CreateMenu(CT_MenuHandler);
	SetMenuTitle(g_hGlobalMenu, "VIP Module SkinColor");
	AddMenuItem(g_hGlobalMenu, "disabled", "Отключить");

	new iCountColors = 1;
	if (KvGotoFirstSubKey(hKeyValues) == true)
	{
		decl String:szItemName[32], String:szCountColors[8];
		do
		{
			if (KvGetSectionName(hKeyValues, szItemName, 32) == true)
			{
				KvGetString(hKeyValues, "name", szItemName, 32);
				KvGetColor(hKeyValues, "rgba",	g_iColorsOfFile[iCountColors][0], g_iColorsOfFile[iCountColors][1], \
												g_iColorsOfFile[iCountColors][2], g_iColorsOfFile[iCountColors][3]);


				IntToString(iCountColors, szCountColors, 8);
				AddMenuItem(g_hGlobalMenu, szCountColors, szItemName);

				iCountColors++;
			}
		}
		while (KvGotoNextKey(hKeyValues) == true && iCountColors <= MAX_COLORS);
	}
	else
	{
		SetFailState("File is empty");
	}

	CloseHandle(hKeyValues);
}

public CT_MenuHandler(Handle:hMenu, MenuAction:iAction, iParam1, iParam2)
{
	switch (iAction)
	{
		case MenuAction_Select:
		{
			if (iParam2 == 0)
			{
				if (g_iClientSelectColor[iParam1] != 0)
				{
					PrintToChat(iParam1, "\x01\x05[VIP Module] \x01Вы отключили раскрашивание скина");
					g_iClientSelectColor[iParam1] = 0;

					ChangeColorSkin(iParam1, 255, 255, 255, 255);
				}
				else
				{
					PrintToChat(iParam1, "\x01\x05[VIP Module] \x01Раскрашивание уже отключено");
				}
			}
			else
			{
				g_iClientSelectColor[iParam1] = iParam2;

				if (IsPlayerAlive(iParam1) == true)
				{
					PrintToChat(iParam1, "\x01\x05[VIP Module] \x01Цвет скина изменен");
				}
				else
				{
					PrintToChat(iParam1, "\x01\x05[VIP Module] \x01Изменения вступят в силу со следующего возрождения");
				}

				ChangeColorSkin(iParam1, g_iColorsOfFile[iParam2][0], g_iColorsOfFile[iParam2][1], g_iColorsOfFile[iParam2][2], g_iColorsOfFile[iParam2][3]);
			}
		}
	}
}

public VIP_OnPlayerSpawn(iClientID, iTeam, bool:bBot, bool:bVip, const String:szSteamID[], const String:szGroup[])
{
	if (g_bIsClientVip[iClientID] == true)
	{
		new iSelect = g_iClientSelectColor[iClientID];
		if (iSelect != 0)
		{
			ChangeColorSkin(iClientID, g_iColorsOfFile[iSelect][0], g_iColorsOfFile[iSelect][1], g_iColorsOfFile[iSelect][2], g_iColorsOfFile[iSelect][3]);
		}
	}
}

stock ChangeColorSkin(iClientID, iRed, iGreen, iBlue, iAlpha)
{
	if (iClientID > 0 && IsPlayerAlive(iClientID) == true)
	{
		SetEntityRenderMode(iClientID, RENDER_TRANSCOLOR);
		SetEntityRenderColor(iClientID, iRed, iGreen, iBlue, iAlpha);
	}
}